=== libs/geometry/test/algorithms/overlaps/CMakeLists.txt ===
# Boost.Geometry
# Copyright (c) 2024 Barend Gehrels, Amsterdam, the Netherlands.
# Use, modification and distribution is subject to the Boost Software License,
# Version 1.0. (See accompanying file LICENSE_1_0.txt or copy at
# http://www.boost.org/LICENSE_1_0.txt)

foreach(item IN ITEMS
    overlaps
    overlaps_areal
    overlaps_box
    overlaps_gc
    overlaps_sph
  )
  boost_geometry_add_unit_test("algorithms" ${item})
endforeach()
