=== libs/geometry/test/algorithms/set_operations/intersection/CMakeLists.txt ===
# Boost.Geometry
# Copyright (c) 2024 Barend Gehrels, Amsterdam, the Netherlands.
# Use, modification and distribution is subject to the Boost Software License,
# Version 1.0. (See accompanying file LICENSE_1_0.txt or copy at
# http://www.boost.org/LICENSE_1_0.txt)

foreach(item IN ITEMS
          intersection
          intersection_multi
        )
  boost_geometry_add_unit_test("algorithms" ${item})
  target_compile_definitions(${BOOST_GEOMETRY_UNIT_TEST_NAME} PRIVATE BOOST_GEOMETRY_TEST_ONLY_ONE_TYPE)
endforeach()

foreach(item IN ITEMS
          intersection_box
          intersection_gc
          intersection_linear_linear
          intersection_areal_areal_linear
          intersection_pl_a
          intersection_pl_l
          intersection_pl_pl
          intersection_tupled
          intersection_integer
        )
  boost_geometry_add_unit_test("algorithms" ${item})
endforeach()
